
% This script is used to test the identification model 
% for three species (Coilia dussumieri, Setipinna taty, and Thryssa hamiltonii) 
% of the Engraulidae family

%%
% list of the testing folders, should be set based on new location of testing folders 
Coilia_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\ENG\Coilia\testing\*.jpg');  
Setipinna_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\ENG\Setipinna\testing\*.jpg');
Thryssa_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\ENG\Thryssa\testing\*.jpg');

% Importing otolith images  and converting them to
% the graysclae images
Coilia_imgs= cell(10,1);
 for Coilia = 1 : length(Coilia_imgs)
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\ENG\Coilia\testing\',Coilia_right(Coilia).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
    Coilia_imgs{Coilia}= grayImage;                        

 end
 
% extracting features of the graysclae images (using Feat_Extr function)
  
 for ii= 1:length(Coilia_imgs)
     
     aa= ii
     
     bb= 1
     
     distances_atrib = Feat_Extr( Coilia_imgs{ii});
     
     test_dataset(aa,:)= distances_atrib;
 end
 
 % predicting species of the speciemens in the corresponding folder
 % using the trained classifier (discriminent_analysis)and extracted
 % features
 
 label(:,bb)= predict(discriminent_analysis, test_dataset);
 clear Coilia_imgs
 
 % Importing otolith images and converting them to
% the graysclae images
 
 Setipinna_imgs= cell(10,1); 
 for Setipinna = 1 : length(Setipinna_imgs)
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\ENG\Setipinna\testing\',Setipinna_right(Setipinna).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
    Setipinna_imgs{Setipinna}= grayImage;                        

 end
 
 % extracting features of the graysclae images (using Feat_Extr function)
  
 for ii= 1:length(Setipinna_imgs)
     
     aa= ii
     bb= 2
     
     distances_atrib = Feat_Extr( Setipinna_imgs{ii});
     
     test_dataset(aa,:)= distances_atrib;
 end
 
 % predicting species of the speciemens in the corresponding folder
 % using the trained classifier (discriminent_analysis)and extracted
 % features
 
  label(:,bb)= predict(discriminent_analysis, test_dataset);
 clear Setipinna_imgs
 
 % Importing otolith images and converting them to
% the graysclae images
 
 Thryssa_imgs= cell(10,1);
 for Thryssa = 1 : length(Thryssa_imgs)
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\ENG\Thryssa\testing\',Thryssa_right(Thryssa).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
    Thryssa_imgs{Thryssa}= grayImage;                         
 end
 
 % extracting features of the graysclae images (using Feat_Extr function)

 for ii= 1:length(Thryssa_imgs)
     
     aa= ii
     bb= 3
     
     distances_atrib = Feat_Extr( Thryssa_imgs{ii});
     
     test_dataset(aa,:)= distances_atrib;
 end
 
 % predicting species of the speciemens in the corresponding folder
 % using the trained classifier (discriminent_analysis)and extracted
 % features
 
  label(:,bb)= predict(discriminent_analysis, test_dataset); % The final label here is used to determine Confusion Matrix of the Engraulidae family (Table 2 of the manuscript) 
 clear Thryssa_imgs
 
 