% This script is used to test the identification model 
% for five species (Dendrophysa russelli, Johnius belangerii, Johnius carouna, Otolithes ruber, and Panna microdon)  
% of the Sciaenidae family

%%
% list of the testing folders, should be set based on new location of the testing folders 
DenRus_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Sciaenidae\DenRus\testing\*.jpg');  
JohBel_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Sciaenidae\JohBel\testing\*.jpg');
JohCar_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Sciaenidae\JohCar\testing\*.jpg');
OtoRub_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Sciaenidae\OtoRub\testing\*.jpg');
PanMic_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Sciaenidae\PanMic\testing\*.jpg');

% Importing otolith images  and converting them to
% the graysclae images
DenRus_imgs= cell(10,1);
 for denrus = 1 : length(DenRus_imgs)
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Sciaenidae\DenRus\testing\',DenRus_right(denrus).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
    DenRus_imgs{denrus}= grayImage;                         

 end
 
 % extracting features of the graysclae images (using Feat_Extr function)

 for ii= 1:length(DenRus_imgs)
     
     aa= ii
     
     bb= 1
     
     distances_atrib = Feat_Extr( DenRus_imgs{ii});
     
     test_dataset(aa,:)= distances_atrib;
 end
 
 % predicting species of the speciemens in the corresponding folder
 % using the trained classifier (discriminent_analysis)and extracted
 % features
 label(:,bb)= predict(discriminent_analysis, test_dataset);
 clear DenRus_imgs
 
% Importing otolith images  and converting them to
% the graysclae images
 JohBel_imgs= cell(10,1); 
 for johbel = 1 : length(JohBel_imgs)
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Sciaenidae\JohBel\testing\',JohBel_right(johbel).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
    JohBel_imgs{johbel}= grayImage;                         

 end
 
 % extracting features of the graysclae images (using Feat_Extr function)
 for ii= 1:length(JohBel_imgs)
     
     aa= ii
     bb= 2
     
     distances_atrib = Feat_Extr( JohBel_imgs{ii});
     
     test_dataset(aa,:)= distances_atrib;
 end
 
 % predicting species of the speciemens in the corresponding folder
 % using the trained classifier (discriminent_analysis)and extracted
 % features
 label(:,bb)= predict(discriminent_analysis, test_dataset);
 clear JohBel_imgs
 
% Importing otolith images  and converting them to
% the graysclae images
 JohCar_imgs= cell(10,1);
 for johcar = 1 : length(JohCar_imgs)
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Sciaenidae\JohCar\testing\',JohCar_right(johcar).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
     JohCar_imgs{johcar}= grayImage;                         
 end
 
 % extracting features of the graysclae images (using Feat_Extr function)
 for ii= 1:length(JohCar_imgs)
     
     aa= ii
     bb= 3
     
     distances_atrib = Feat_Extr( JohCar_imgs{ii});
     
     test_dataset(aa,:)= distances_atrib;
 end
 
 % predicting species of the speciemens in the corresponding folder
 % using the trained classifier (discriminent_analysis)and extracted
 % features
 label(:,bb)= predict(discriminent_analysis, test_dataset);
 clear JohCar_imgs
 
 % Importing otolith images  and converting them to
% the graysclae images
 OtoRub_imgs= cell(10,1);
 for otorub = 1 : length(OtoRub_imgs)
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Sciaenidae\OtoRub\testing\',OtoRub_right(otorub).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
     OtoRub_imgs{otorub}= grayImage;                        

 end
 
 % extracting features of the graysclae images (using Feat_Extr function)
 for ii= 1:length(OtoRub_imgs)
     
     aa= ii
     bb= 4
     
     distances_atrib = Feat_Extr( OtoRub_imgs{ii});
     
     test_dataset(aa,:)= distances_atrib;
 end
 
 % predicting species of the speciemens in the corresponding folder
 % using the trained classifier (discriminent_analysis)and extracted
 % features
 label(:,bb)= predict(discriminent_analysis, test_dataset);
 clear OtoRub_imgs
 
 % Importing otolith images  and converting them to
% the graysclae images
 PanMic_imgs= cell(10,1);
 for panmic = 1 : length( PanMic_imgs)
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Sciaenidae\PanMic\testing\',PanMic_right(panmic).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
    PanMic_imgs{panmic}= grayImage;                         

 end
 
 % extracting features of the graysclae images (using Feat_Extr function)
 for ii= 1:length( PanMic_imgs)
     
     aa= ii
     bb= 5
     
     distances_atrib = Feat_Extr(  PanMic_imgs{ii});
     
     test_dataset(aa,:)= distances_atrib;
 end
 
 % predicting species of the speciemens in the corresponding folder
 % using the trained classifier (discriminent_analysis)and extracted
 % features
 label(:,bb)= predict(discriminent_analysis, test_dataset);   % The final label here is used to determine Confusion Matrix of the Sciaenidae family (Table 3 of the manuscript) 
 clear  PanMic_imgs
 