% This script is used to train the identification model 
% for six species (Nemapteryx caelatus, Arius maculatus, Cryptarius truncatus, Hexanematichtys sagor, Osteogeneiosus militaris, and Plicofollis argyropleuron ) 
% of the Ariida family

clear all

%% 

% list of training folders of the corresponding species, should be set
% based on new location of the training data set folders
Nemcae_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Ariidae\Nemcae\training\*.jpg');  
AriMac_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Ariidae\AriMac\training\*.jpg');
CryTru_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Ariidae\CryTru\training\*.jpg');
HexSag_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Ariidae\HexSag\training\*.jpg');
OstMil_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Ariidae\OstMil\training\*.jpg');
PliArg_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Ariidae\PliArg\training\*.jpg');                             

% Importing otolith images of the Nemapteryx caelatus and converting them to
% the graysclae images

Nemcae_imgs= cell(18,1);
 for Nemcae = 1 : 18
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Ariidae\Nemcae\training\',Nemcae_right(Nemcae).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
   Nemcae_imgs{Nemcae}= grayImage;                         

 end
 
 % extracting features of the graysclae images of Nemapteryx caelatus species (using Feat_Extr function) 
 for ii= 1:length(Nemcae_imgs)
     
     aa= ii
     
     distances_atrib = Feat_Extr( Nemcae_imgs{ii});
     
     train_dataset(aa,:)= distances_atrib;
 end
 
 clear Nemcae_imgs
 
% Importing otolith images of the Arius maculatus and converting them to
% the graysclae images
 AriMac_imgs= cell(18,1); 
 for AriMac = 1 : 18
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Ariidae\AriMac\training\',AriMac_right(AriMac).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
    AriMac_imgs{AriMac}= grayImage;                         

 end
 
  % extracting features of the graysclae images of Arius maculatus species (using Feat_Extr function) 
 for ii= 1:length(AriMac_imgs)
     
     aa= aa+1
     
     distances_atrib = Feat_Extr( AriMac_imgs{ii});
     
     train_dataset(aa,:)= distances_atrib;
 end
 
 clear AriMac_imgs
 
 % Importing otolith images of the Cryptarius truncatus and converting them to
% the graysclae images
 CryTru_imgs= cell(18,1);
 for CryTru = 1 : 18
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Ariidae\CryTru\training\', CryTru_right( CryTru).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
     CryTru_imgs{CryTru}= grayImage;                        
 end
 
 % extracting features of the graysclae images of Cryptarius truncatus species (using Feat_Extr function) 
 for ii= 1:length(CryTru_imgs)
     
     aa= aa+1
     
     distances_atrib = Feat_Extr(  CryTru_imgs{ii});
     
     train_dataset(aa,:)= distances_atrib;
 end
 clear  CryTru_imgs
 
% Importing otolith images of the Hexanematichtys sagor and converting them to
% the graysclae images
 HexSag_imgs= cell(18,1);
 for HexSag = 1 : 18
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Ariidae\HexSag\training\',HexSag_right(HexSag).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
    HexSag_imgs{HexSag}= grayImage;                         

 end
 
 % extracting features of the graysclae images of Hexanematichtys sagor species (using Feat_Extr function) 
 for ii= 1:length(HexSag_imgs)
     
     aa= aa+1
     
     distances_atrib = Feat_Extr( HexSag_imgs{ii});
     
     train_dataset(aa,:)= distances_atrib;
 end
 clear HexSag_imgs
 
 
 % Importing otolith images of the Osteogeneiosus militaris and converting them to
% the graysclae images
 OstMil_imgs= cell(18,1);
 for OstMil = 1 : 18
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Ariidae\OstMil\training\',OstMil_right(OstMil).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
   OstMil_imgs{OstMil}= grayImage;                         

 end
 
 % extracting features of the graysclae images of Osteogeneiosus militaris species (using Feat_Extr function) 
 for ii= 1:length( OstMil_imgs)
     
     aa= aa+1
     
     distances_atrib = Feat_Extr(  OstMil_imgs{ii});
     
     train_dataset(aa,:)= distances_atrib;
 end
 clear  OstMil_imgs
 
 % Importing otolith images of the Plicofollis argyropleuron and converting them to
% the graysclae images
 PliArg_imgs= cell(18,1);
 for PliArg = 1 : 18
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Ariidae\PliArg\training\',PliArg_right(PliArg).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
   PliArg_imgs{PliArg}= grayImage;                         

 end
 
 % extracting features of the graysclae images of Plicofollis argyropleuron species (using Feat_Extr function) 
 for ii= 1:length( PliArg_imgs)
     
     aa= aa+1
     
     distances_atrib = Feat_Extr(  PliArg_imgs{ii});
     
     train_dataset(aa,:)= distances_atrib;
 end
 clear PliArg_imgs
 
 % class labels based on the name of the species 

 for ii= 1:Nemcae
  Species{ii,1}= char('Nemcae')
end
length_1= length(Species);
for ii= 1:AriMac
    Species{ii+length_1,1}= char('AriMac')
end

length_2= length(Species);
for ii= 1:CryTru
    Species{ii+length_2,1}= char('CryTru')
end

length_3= length(Species);
for ii= 1:HexSag
    Species{ii+length_3,1}= char('HexSag')
end

length_4= length(Species);
for ii= 1:OstMil
    Species{ii+length_4,1}= char('OstMil')
end

length_5= length(Species);
for ii= 1:PliArg
    Species{ii+length_5,1}= char('PliArg')
end

%% training the discriminent analysis classifier using extracted features and class labels 
     
discriminent_analysis = fitcdiscr(train_dataset,Species);
