
% This script is used to train the identification model 
% for three species (Coilia dussumieri, Setipinna taty, and Thryssa hamiltonii) 
% of the Engraulidae family
clear all

%% 
% list of training folders of the corresponding species, should be set
% based on new location of the training data set folders
Coilia_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\ENG\Coilia\training\*.jpg');  
Setipinna_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\ENG\Setipinna\training\*.jpg');
Thryssa_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\ENG\Thryssa\training\*.jpg');

                             
% Importing otolith images of the Coilia dussumieri and converting them to
% the graysclae images

Coilia_imgs= cell(20,1);
 for Coilia = 1 : 20
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\ENG\Coilia\training\',Coilia_right(Coilia).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
    Coilia_imgs{Coilia}= grayImage;                     

 end
 
 % extracting features of the graysclae images of Coilia dussumieri species (using Feat_Extr function) 
 
 for ii= 1:length(Coilia_imgs)
     
     aa= ii
     
     distances_atrib = Feat_Extr( Coilia_imgs{ii});
     
     train_dataset(aa,:)= distances_atrib;
 end
 
 clear Coilia_imgs
 
 % Importing otolith images of the Setipinna taty and converting them to
% the graysclae images
 
 Setipinna_imgs= cell(20,1); 
 for Setipinna = 1 : 20
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\ENG\Setipinna\training\',Setipinna_right(Setipinna).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
    Setipinna_imgs{Setipinna}= grayImage;                        

 end
 
 % extracting features of the graysclae images of Setipinna taty species (using Feat_Extr function)
  
 for ii= 1:length(Setipinna_imgs)
     
     aa= aa+1
     
     distances_atrib = Feat_Extr( Setipinna_imgs{ii});
     
     train_dataset(aa,:)= distances_atrib;
 end
 
 clear Setipinna_imgs
 
 % Importing otolith images of the Thryssa hamiltonii and converting them to
% the graysclae images
 
Thryssa_imgs= cell(20,1);
 for Thryssa = 1 : 20
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\ENG\Thryssa\training\',Thryssa_right(Thryssa).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
    Thryssa_imgs{Thryssa}= grayImage;                         
 end
 
 % extracting features of the graysclae images of Thryssa hamiltonii species (using Feat_Extr function)
 
 for ii= 1:length(Thryssa_imgs)
     
     aa= aa+1
     
     distances_atrib = Feat_Extr( Thryssa_imgs{ii});
     
     train_dataset(aa,:)= distances_atrib;
 end
 clear Thryssa_imgs

 
% class labels based on the name of the species 

 for ii= 1:Coilia
  Species{ii,1}= char('Coilia')
end
length_1= length(Species);
for ii= 1:Setipinna
    Species{ii+length_1,1}= char('Setipinna')
end

length_2= length(Species);
for ii= 1:Thryssa
    Species{ii+length_2,1}= char('Thryssa')
end



%% training the discriminent analysis classifier using extracted features and class labels 

discriminent_analysis = fitcdiscr(train_dataset,Species); % trained model (classifier)


