% This script is used to train the identification model 
% for five species (Dendrophysa russelli, Johnius belangerii, Johnius carouna, Otolithes ruber, and Panna microdon) 
% of the Sciaenidae family

clear all

%% 

% list of training folders of the corresponding species, should be set
% based on new location of the training data set folders
DenRus_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Sciaenidae\DenRus\training\*.jpg');  
JohBel_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Sciaenidae\JohBel\training\*.jpg');
JohCar_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Sciaenidae\JohCar\training\*.jpg');
OtoRub_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Sciaenidae\OtoRub\training\*.jpg');
PanMic_right= dir('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Sciaenidae\PanMic\training\*.jpg');
                             
% Importing otolith images of the Dendrophysa russelli and converting them to
% the graysclae images

DenRus_imgs= cell(19,1);
 for denrus = 1 : 19
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Sciaenidae\DenRus\training\',DenRus_right(denrus).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
    DenRus_imgs{denrus}= grayImage;                         

 end
 
 % extracting features of the graysclae images of Dendrophysa russelli species (using Feat_Extr function) 
 for ii= 1:length(DenRus_imgs)
     
     aa= ii
     
     distances_atrib = Feat_Extr( DenRus_imgs{ii});
     
     train_dataset(aa,:)= distances_atrib;
 end
 
 clear DenRus_imgs
 
 % Importing otolith images of the Johnius belangerii and converting them to
% the graysclae images
 JohBel_imgs= cell(19,1); 
 for johbel = 1 : 19
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Sciaenidae\JohBel\training\',JohBel_right(johbel).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
    JohBel_imgs{johbel}= grayImage;                         

 end
 
 % extracting features of the graysclae images of Johnius belangerii species (using Feat_Extr function) 
 for ii= 1:length(JohBel_imgs)
     
     aa= aa+1
     
     distances_atrib = Feat_Extr( JohBel_imgs{ii});
     
     train_dataset(aa,:)= distances_atrib;
 end
 
 clear JohBel_imgs
 
 % Importing otolith images of the Johnius carouna and converting them to
% the graysclae images
 JohCar_imgs= cell(19,1);
 for johcar = 1 : 19
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Sciaenidae\JohCar\training\',JohCar_right(johcar).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
     JohCar_imgs{johcar}= grayImage;                         
 end
 
 % extracting features of the graysclae images of Johnius carouna species (using Feat_Extr function) 
 for ii= 1:length(JohCar_imgs)
     
     aa= aa+1
     
     distances_atrib = Feat_Extr( JohCar_imgs{ii});
     
     train_dataset(aa,:)= distances_atrib;
 end
 clear JohCar_imgs
 
 % Importing otolith images of the Otolithes ruber and converting them to
% the graysclae images
 OtoRub_imgs= cell(19,1);
 for otorub = 1 : 19
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Sciaenidae\OtoRub\training\',OtoRub_right(otorub).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
     OtoRub_imgs{otorub}= grayImage;                        

 end
 
 % extracting features of the graysclae images of Otolithes ruber species (using Feat_Extr function) 
 for ii= 1:length(OtoRub_imgs)
     
     aa= aa+1
     
     distances_atrib = Feat_Extr( OtoRub_imgs{ii});
     
     train_dataset(aa,:)= distances_atrib;
 end
 clear OtoRub_imgs
 
 
  % Importing otolith images of the Panna microdon and converting them to
% the graysclae images
 PanMic_imgs= cell(19,1);
 for panmic = 1 : 19
    filename = strcat('C:\Users\Lenovo\Desktop\Nima_Otolith\nima\Final\Final Dataset\Sciaenidae\PanMic\training\',PanMic_right(panmic).name);
    img = imread(filename);
    grayImage=rgb2gray(img);         
    PanMic_imgs{panmic}= grayImage;                         

 end
 
 % extracting features of the graysclae images of Panna microdon species (using Feat_Extr function) 
 for ii= 1:length( PanMic_imgs)
     
     aa= aa+1
     
     distances_atrib = Feat_Extr(  PanMic_imgs{ii});
     
     train_dataset(aa,:)= distances_atrib;
 end
 clear  PanMic_imgs
 
% class labels based on the name of the species 

 for ii= 1:denrus
  Species{ii,1}= char('DenRus')
end
length_1= length(Species);
for ii= 1:johbel
    Species{ii+length_1,1}= char('JohBel')
end

length_2= length(Species);
for ii= 1:johcar
    Species{ii+length_2,1}= char('JohCar')
end

length_3= length(Species);
for ii= 1:otorub
    Species{ii+length_3,1}= char('OtoRub')
end

length_4= length(Species);
for ii= 1:panmic
    Species{ii+length_4,1}= char('PanMic')
end



%% training the discriminent analysis classifier using extracted features and class labels 

discriminent_analysis = fitcdiscr(train_dataset,Species);  % trained model (classifier)

